<?php

define('AVTHEME','altervista-theme');

add_action('after_setup_theme', 'avtheme_after_setup');
function avtheme_after_setup() {
	
	add_theme_support( 'post-thumbnails' );
	add_image_size('home-thumbnail', 160, 120, true);
	add_image_size('slider-thumbnail', 1000, 360, true);
	add_image_size('showcase-thumbnail', 660, 328, true);
	load_theme_textdomain( AVTHEME , get_stylesheet_directory() . '/langs' );
	add_filter('excerpt_length', 'avtheme_new_excerpt_length');
	function avtheme_new_excerpt_length($length){return 60;}
	
}

add_action( 'admin_print_styles', 'avtheme_admin_enqueue_css' );
function avtheme_admin_enqueue_css() {
	
	wp_enqueue_style( 'avtheme-options', get_stylesheet_directory_uri() . '/admin/style.css', null, '2011-04-28' );
	wp_enqueue_style( 'avtheme-te-options', get_template_directory_uri() . '/inc/theme-options.css', null, '2011-04-28' );

}

register_sidebar( array(
        'name' => __( 'Secondary Sidebar', AVTHEME ),
        'id' => 'sidebar-6',
        'before_widget' => '<aside id="%1$s" class="widget %2$s">',
        'after_widget' => "</aside>",
        'before_title' => '<h3 class="widget-title">',
        'after_title' => '</h3>',
) );


add_filter( 'twentyeleven_color_schemes', 'avtheme_color_schemes' );
function avtheme_color_schemes( $color_schemes ) {
  	
  	unset($color_schemes['light']);
	$color_schemes['light'] = array(
                'value' => 'light',
                'label' => __( 'Light', AVTHEME ),
                'thumbnail' => get_stylesheet_directory_uri() . '/inc/images/light.png',
                'default_link_color' => '#dd362f',
        );
  	
  	  
    unset($color_schemes['dark']);
	$color_schemes['avdark'] = array(
                'value' => 'avdark',
                'label' => __( 'Dark', AVTHEME ),
                'thumbnail' => get_stylesheet_directory_uri() . '/inc/images/dark.png',
                'default_link_color' => '#e4741f',
        );
    
    unset($color_schemes['green']);
	$color_schemes['avgreen'] = array(
                'value' => 'avgreen',
                'label' => __( 'Green', AVTHEME ),
                'thumbnail' => get_stylesheet_directory_uri() . '/inc/images/green.png',
                'default_link_color' => '#59a800',
        );
    
    unset($color_schemes['minimal']);
	$color_schemes['avminimal'] = array(
                'value' => 'avminimal',
                'label' => __( 'Minimal', AVTHEME ),
                'thumbnail' => get_stylesheet_directory_uri() . '/inc/images/minimal.png',
                'default_link_color' => '#00abda',
        );
    
    unset($color_schemes['magenta']);
	$color_schemes['avmagenta'] = array(
                'value' => 'avmagenta',
                'label' => __( 'Magenta', AVTHEME ),
                'thumbnail' => get_stylesheet_directory_uri() . '/inc/images/magenta.png',
                'default_link_color' => '#D40073',
        );
    
    unset($color_schemes['orange']);
	$color_schemes['avorange'] = array(
                'value' => 'avorange',
                'label' => __( 'Orange', AVTHEME ),
                'thumbnail' => get_stylesheet_directory_uri() . '/inc/images/orange.png',
                'default_link_color' => '#F85700',
        );
    
    unset($color_schemes['red']);
	$color_schemes['avred'] = array(
                'value' => 'avred',
                'label' => __( 'Red', AVTHEME ),
                'thumbnail' => get_stylesheet_directory_uri() . '/inc/images/red.png',
                'default_link_color' => '#da1027',
        );
   	
   	unset($color_schemes['pink']);
	$color_schemes['avpink'] = array(
                'value' => 'avpink',
                'label' => __( 'Pink', AVTHEME ),
                'thumbnail' => get_stylesheet_directory_uri() . '/inc/images/pink.png',
                'default_link_color' => '#f153d3',
        );
   	          
    unset($color_schemes['grey']);
	$color_schemes['avgrey'] = array(
                'value' => 'avgrey',
                'label' => __( 'Grey', AVTHEME ),
                'thumbnail' => get_stylesheet_directory_uri() . '/inc/images/grey.png',
                'default_link_color' => '#d40019',
        );  
     
    unset($color_schemes['grey-dark']);
	$color_schemes['avgrey-dark'] = array(
                'value' => 'avgrey-dark',
                'label' => __( 'Grey Dark', AVTHEME ),
                'thumbnail' => get_stylesheet_directory_uri() . '/inc/images/grey-dark.png',
                'default_link_color' => '#f8d400',
        );  
      
        
	return $color_schemes;
}


add_action( 'twentyeleven_enqueue_color_scheme', 'avtheme_enqueue_color_scheme' );
function avtheme_enqueue_color_scheme( $color_scheme ) {
	if ( 'avdark' == $color_scheme ) {
		wp_enqueue_style( 'avdark', get_stylesheet_directory_uri() . '/colors/dark.css', array(), null );
	}
	elseif ( 'avgreen' == $color_scheme ) {
		wp_enqueue_style( 'avgreen', get_stylesheet_directory_uri() . '/colors/green.css', array(), null );
	}
	elseif ( 'avminimal' == $color_scheme ) {
		wp_enqueue_style( 'avminimal', get_stylesheet_directory_uri() . '/colors/minimal.css', array(), null );
	}
	elseif ( 'avmagenta' == $color_scheme ) {
		wp_enqueue_style( 'avmagenta', get_stylesheet_directory_uri() . '/colors/magenta.css', array(), null );
	}
	elseif ( 'avorange' == $color_scheme ) {
		wp_enqueue_style( 'avorange', get_stylesheet_directory_uri() . '/colors/orange.css', array(), null );
	}
	elseif ( 'avred' == $color_scheme ) {
		wp_enqueue_style( 'avred', get_stylesheet_directory_uri() . '/colors/red.css', array(), null );
	}
	elseif ( 'avpink' == $color_scheme ) {
		wp_enqueue_style( 'avpink', get_stylesheet_directory_uri() . '/colors/pink.css', array(), null );
	}
	elseif ( 'avgrey' == $color_scheme ) {
		wp_enqueue_style( 'avgrey', get_stylesheet_directory_uri() . '/colors/grey.css', array(), null );
	}
	elseif ( 'avgrey-dark' == $color_scheme ) {
		wp_enqueue_style( 'avgrey-dark', get_stylesheet_directory_uri() . '/colors/grey-dark.css', array(), null );
	}
}

add_filter('twentyeleven_theme_options_validate','avtheme_reset_title_color', 10, 3);
function avtheme_reset_title_color($input, $output, $defaults) {
	
	$options = twentyeleven_get_theme_options();
	if($input['color_scheme'] != $options['color_scheme'] ) {
		remove_theme_mod('header_textcolor');
	}
	
	return $output;
}


add_filter( 'twentyeleven_layouts', 'avtheme_layouts' );
function avtheme_layouts ($layout_options) {
    
    $layout_options['three-columns-middle'] = array(
        'value' => 'three-columns-middle',
        'label' => __( 'Two sidebars, content in the middle', AVTHEME ),
        'thumbnail' => get_stylesheet_directory_uri() . '/inc/images/two-sidebars-content-middle.png',
    );
    
    $layout_options['three-columns-right'] = array(
        'value' => 'three-columns-right',
        'label' => __( 'Two sidebars, content on right', AVTHEME ),
        'thumbnail' => get_stylesheet_directory_uri() . '/inc/images/two-sidebars-content-right.png', 
    );
    
    $layout_options['three-columns-left'] = array(
        'value' => 'three-columns-left',
        'label' => __( 'Two sidebars, content on left', AVTHEME ),
        'thumbnail' => get_stylesheet_directory_uri() . '/inc/images/two-sidebars-content-left.png',
    );
    
    unset($layout_options['content']);
    
    return($layout_options);

}


add_filter( 'twentyeleven_layout_classes', 'avtheme_layout_classes', 10, 2 );
function avtheme_layout_classes( $classes, $current_layout) {
   
        switch($current_layout) {
            case 'content-sidebar':
                $classes = array( 'two-column', 'right-sidebar' );
                break;
            case 'sidebar-content':
                $classes = array( 'two-column', 'left-sidebar' );
                break;
            case 'three-columns-middle':
                $classes = array( 'three-column', 'content-middle' );
                break;
            case 'three-columns-right':
                $classes = array( 'three-column', 'content-right' );
                break;
            case 'three-columns-left':
                $classes = array( 'three-column', 'content-left' );
                break;
            default:
                $classes = array( 'two-column', 'right-sidebar' );
                break;
        }
        
        return $classes;
    
}

/*
add_action( 'admin_print_styles-appearance_page_theme_options', 'avtheme_admin_enqueue_scripts' );
function avtheme_admin_enqueue_scripts( $hook_suffix ) {
	wp_enqueue_script( 'avtheme-options', get_stylesheet_directory_uri() . '/inc/theme-options.js', array( 'farbtastic', 'twentyeleven-theme-options' ), '2012-02-13' );
}*/

add_action('get_header','avtheme_nivo_slider_add_script');
function avtheme_nivo_slider_add_script () {

	wp_register_style('flexslider.css', get_stylesheet_directory_uri().'/inc/slider/flexslider.css');
	wp_register_script('flexslider.js', get_stylesheet_directory_uri() . '/inc/slider/jquery.flexslider-min.js', array('jquery'));
	
	if (!is_admin()) {
		
		wp_enqueue_style('flexslider.css');
		wp_enqueue_script('flexslider.js');

	}
	
}

add_action('admin_menu', 'avtheme_admin_menu');
function avtheme_admin_menu() {
	add_submenu_page('themes.php', __('Slider &amp; Home Settings'), __('Slider &amp; Home'), 'manage_options', 'slider_home', 'avtheme_slider_home_admin_page');
}

function avtheme_slider_home_admin_page() {
	?>
	
	<div class="wrap">
	<?php screen_icon(); ?>
	<h2>AlterVista</h2>

		<form action="options.php" method="post">
	
			<?php settings_fields('avtheme_slider_options'); ?>
			<?php do_settings_sections('slider_home'); ?>
			<div id="insertadv-buttons">
				<input class="button-primary" name="Submit" type="submit" value="<?php _e('Save Changes',AVOPT); ?>" />
			</div>
	
		</form>

	</div>
	
	<?php
}

add_action('admin_init', 'avtheme_register_settings');
function avtheme_register_settings() {
	
	twentyeleven_theme_options_init();

	remove_action( 'admin_init', 'twentyeleven_theme_options_init' );
	
	register_setting(
		'avtheme_slider_options',
		'avtheme_slider_options',
		'avtheme_slider_options_validate'
	);
	add_settings_section(
		'avtheme_slider_options',
		__('Slider settings', AVTHEME),
		'avtheme_slider_options_info',
		'slider_home'
	);
	add_settings_field(
		'avtheme_slider_enabled',
		__('Use slider instead of header image', AVTHEME),
		'avtheme_slider_enable_option',
		'slider_home',
		'avtheme_slider_options'
	);
	
	add_settings_field(
		'avtheme_slider_category',
		__('Choose category of posts displayed', AVTHEME),
		'avtheme_slider_category_option',
		'slider_home',
		'avtheme_slider_options'
	);
	
	add_settings_field(
		'avtheme_slider_number',
		__('Choose number of posts displayed', AVTHEME),
		'avtheme_slider_number_option',
		'slider_home',
		'avtheme_slider_options'
	);
	
	add_settings_section (
		'avtheme_home_options',
		__('Home page settings', AVTHEME),
		'avtheme_home_options_info',
		'slider_home'
	);
	
	add_settings_field (
		'avtheme_home_loop',
		__('Display posts as', AVTHEME),
		'avtheme_home_loop_option',
		'slider_home',
		'avtheme_home_options'
	);
	
}


function avtheme_home_options_info() {
	?>
	<p><?php _e('Choose how to display posts in home page and archives pages', AVTHEME); ?></p>
	<?php
}

function avtheme_home_loop_option() {

	$avtheme_slider_options =  get_option('avtheme_slider_options');
	if(!isset($avtheme_slider_options['full_post'])) {
		$avtheme_slider_options['full_post'] = 0;
	}
	
	?>
		<div class="layout image-radio-option theme-layout">
			<label for="avtheme_home_excerpt" class="description">
				<input id="avtheme_home_excerpt" type="radio" name="avtheme_slider_options[full_post]" value="0" <?php checked($avtheme_slider_options['full_post'], 0); ?> />
				<span><?php _e('Excerpt and thumbnail', AVTHEME); ?></span>
			</label>
		</div>
		<div class="layout image-radio-option theme-layout">
			
			<label for="avtheme_home_full" class="description">
				<input id="avtheme_home_full" type="radio" name="avtheme_slider_options[full_post]" value="1" <?php checked($avtheme_slider_options['full_post'], 1); ?> />
				<span><?php _e('Full post', AVTHEME); ?></span>
			</label>
		</div>
	<?php
	
	
}

function avtheme_slider_options_info() {
	
	?>
		<p><?php _e('Activate e manage the featured post slider.', AVTHEME); ?><br />
		<span style="color:red;"><?php _e('Warning: featured images must be at least 1000px wide to be displayed properly.', AVTHEME); ?></span>
		</p>
		
	<?php
	
}

function avtheme_slider_options_validate($input) {
	
	$output['slider'] = ($input['slider'] == 1) ? 1 : 0;
	$output['full_post'] = ($input['full_post'] == 1) ? 1 : 0;
	$output['slider_category'] = is_numeric($input['slider_category']) ? $input['slider_category'] : 'all';
	$output['slider_number'] = is_numeric($input['slider_number']) ? $input['slider_number'] : 5;
	return $output;
	
}

function avtheme_slider_category_option() {
	
	$avtheme_slider_options =  get_option('avtheme_slider_options');
	
	?>
		<select name="avtheme_slider_options[slider_category]" id="slider-category">
			<option value="all" <?php selected( $avtheme_slider_options['slider_category'], 'all' ); ?>><?php _e('All categories', AVTHEME); ?></option>
			<option></option>
			<?php
				$categories = get_categories();
				foreach ($categories as $category) {
					?>
					<option value="<?php echo $category->cat_ID; ?>" <?php selected( $avtheme_slider_options['slider_category'], $category->cat_ID ); ?>><?php echo $category->name; ?></option>
					<?php
				}
			?>
		</select>
		
	<?
}

function avtheme_slider_number_option() {
	
	$avtheme_slider_options =  get_option('avtheme_slider_options');
	if(!isset($avtheme_slider_options['slider_number'])) {
		$avtheme_slider_options['slider_number'] = 5;
	}
	
	?>
		<select name="avtheme_slider_options[slider_number]" id="slider-number">
			<option></option>
			<?php
				$categories = get_categories();
				for ($i = 1; $i <= 10; $i++) {
					?>
					<option value="<?php echo $i; ?>" <?php selected( $avtheme_slider_options['slider_number'], $i ); ?>><?php echo $i; ?></option>
					<?php
				}
			?>
		</select>
		
	<?
}


function avtheme_slider_enable_option() {
	
	$avtheme_slider_options =  get_option('avtheme_slider_options');
	
	?>
		<div class="layout image-radio-option theme-layout">
			<label for="avtheme_slider_enabled" class="description">
				<input id="avtheme_slider_enabled" type="radio" name="avtheme_slider_options[slider]" value="1" <?php checked($avtheme_slider_options['slider'], 1); ?> />
				<span>
					<img src="<?php bloginfo('stylesheet_directory'); ?>/inc/images/slider.png" alt="">
					<?php _e('Slider', AVTHEME); ?>
				</span>
			</label>
		</div>
		<div class="layout image-radio-option theme-layout">
			<label for="avtheme_slider_disabled" class="description">
				<input id="avtheme_slider_disabled" type="radio" name="avtheme_slider_options[slider]" value="0" <?php checked($avtheme_slider_options['slider'], 0); ?> />
				<span>
					<img src="<?php bloginfo('stylesheet_directory'); ?>/inc/images/static-image.png" alt="">
					<?php _e('Static Image', AVTHEME); ?>
				</span>
			</label>
		</div>
	<?php
	
}


add_action( 'wp_head', 'avtheme_print_link_color_style', 1 );
function avtheme_print_link_color_style() {
	
	remove_action( 'wp_head', 'twentyeleven_print_link_color_style' );
	$options = twentyeleven_get_theme_options();
	$link_color = $options['link_color'];

	$default_options = twentyeleven_get_default_theme_options();

	// Don't do anything if the current link color is the default.
	if ( $default_options['link_color'] == $link_color )
		return;
?>
	<style>
		/* Link color */
		a,
		#site-title a:focus,
		#site-title a:hover,
		#site-title a:active,
		.entry-title a:hover,
		.entry-title a:focus,
		.entry-title a:active,
		.widget_twentyeleven_ephemera .comments-link a:hover,
		section.recent-posts .other-recent-posts a[rel="bookmark"]:hover,
		section.recent-posts .other-recent-posts .comments-link a:hover,
		.format-image footer.entry-meta a:hover,
		#site-generator a:hover {
			color: <?php echo $link_color; ?>;
		}
		section.recent-posts .other-recent-posts .comments-link a:hover {
			border-color: <?php echo $link_color; ?>;
		}
		article.feature-image.small .entry-summary p a:hover,
		.entry-header .comments-link a:hover,
		.entry-header .comments-link a:focus,
		.entry-header .comments-link a:active,
		.feature-slider a.active {
			background-color: <?php echo $link_color; ?>;
		}
		#access .current-menu-item > a,
		#access .current-menu-ancestor > a,
		#access .current_page_item > a,
		#access .current_page_ancestor > a {
			color: <?php echo $link_color; ?>;
		}
	</style>
<?php
}


function avtheme_excerpt($num) {
	$limit = $num+1;
	$excerpt = explode(' ', get_the_excerpt(), $limit);
	array_pop($excerpt);
	$excerpt = implode(" ",$excerpt)."... (<a href='" .get_permalink($post->ID) ." '>".__('Read more', AVTHEME)."</a>)";
	echo $excerpt;
    }
    
add_filter('wp_nav_menu_objects','avtheme_add_menu_parent_class');
	
	
function avtheme_add_menu_parent_class($items) {
    foreach ($items as &$item) {
        if (avtheme_hasSub($item->ID, &$items)) {
            $item->classes[] = 'menu-parent-item'; // all elements of field "classes" of a menu item get join together and render to class attribute of <li> element in HTML
            break;
        }
    }
    return $items;    
}

function avtheme_hasSub($menu_item_id, &$items) {
	foreach ($items as $item) {
	    if ($item->menu_item_parent && $item->menu_item_parent==$menu_item_id) {
		return true;
	    }
	}
	return false;
};


?>